unit Ens1371;

interface

uses mymem,unit2,pci,pcix,sysutils,dialogs,winprocs,forms,inifiles;

const ininame='ap137x.ini';
var CTactive:boolean;
cnt,last:longint;


var DACid:byte;

const nil8=$80;
const nil16=$FF;
var nilfil:byte;

const defmyPCIHI=$01E0;
const defmyPCILO=$0000;
const defmyPCImem=$01E00000;{memory location}
var myPCIHI:word;
var myPCILO:word;
var myPCImem:longint;{memory location}


const AC97CODEC=$14;
AC97_RESET=00;{reset codec}
AC97_MASTER_VOLUME=$02;{Master volume}
AC97_LINEINPUT_VOLUME=$10;{PCM output volume}
AC97_CD_VOLUME=$12;{PCM output volume}
AC97_PCM_VOLUME=$18;{PCM output volume}


const SERIAL=$20;

SR_DAC1_Trunc_and_N=$70;  { DAC1 trunc and N register}
SR_DAC1_VFI_ACI=$71;  { DAC1 VFI(15:10) ACI(7:0)}
SR_DAC1_ACC=$72; { DAC1 Accumulator}
SR_DAC1_VFreq=$73; { DAC1 VFreq}
SR_DAC2_Trunc_and_N=$74;  { DAC2 trunc and N register}
SR_DAC2_VFI_ACI=$75;  { DAC2 VFI(15:10) ACI(7:0)}
SR_DAC2_ACC=$76; { DAC2 Accumulator}
SR_DAC2_VFreq=$77;  { DAC2 VFreq}
SR_ADC_Trunc_and_N=$78;  { ADC trunc and N register}
SR_ADC_VFI_ACI=$79;  { ADC VFI(15:10) ACI(7:0)}
SR_ADC_ACC=$7A; { ADC Accumulator}
SR_ADC_VFreq=$7B;  { ADC VFreq}

SR_DAC1_LVOL=$7C;{ DAC1 playback vol left}
SR_DAC1_RVOL=$7D;{ DAC1 playback vol right}
SR_DAC2_LVOL=$7E;{ DAC2 playback vol left}
SR_DAC2_RVOL=$7F;{ DAC2 playback vol right}






var samcon:boolean;


var ddret:word;

{common constants}
{const Bit:array[0..7] of byte=(1,2,4,8,16,32,64,128);}
const BIT0=1;
const BIT1=2;
const BIT2=4;
const BIT3=8;
const BIT4=$10;
const BIT5=$20;
const BIT6=$40;
const BIT7=$80;
const BIT8=$100;
const BIT9=$200;
const BIT10=$400;
const BIT11=$800;
const BIT12=$1000;
const BIT13=$2000;
const BIT14=$4000;
const BIT15=$8000;
const BIT16=$10000;
const BIT17=$20000;
const BIT18=$40000;
const BIT19=$80000;
const BIT20=$100000;
const BIT21=$200000;
const BIT22=$400000;
const BIT23=$800000;
const BIT24=$1000000;
BIT25=$2000000;
BIT26=$4000000;
BIT27=$8000000;
BIT28=$10000000;
BIT29=$20000000;
BIT30=$40000000;
BIT31=$80000000;


const Stereo_Bit=Bit0;
const Sixteen_Bit=Bit1;


const Sample_rate_converter=$10;
{you have to set ALL of these before you turn on the converter!}




{ENS1371 Card info}
const MemoryPageSwap=$c;
var drivername:string;

var ens1371port:word;{the ens1371's port[X]}

var mydrvoffset:longint;
var myvol:longint;


{PCI card data to acquire}
var pciBUS:byte; {The PCI BUS}
var pciFunc:byte;{The PCI BUS index}
VAR pciDevice:Byte;{The PCI device?}

{data for PCI vendor ID}
const PCIcardVendor=$1274;{ensoniq}

{AudioPCI cards}
const PCIcardDeviceID1=$1371;{chip ES1371 [AudioPCI]}
{HP CT5801 0043,  Revision ID=$09 ,"chip says creative es1373"}
{Audio PCI 5000,  Revision ID=$02 ,"chip says es1371"}

const PCIcardDeviceID2=$5880;{chip ct5880 }
const PCIcardDeviceID3=$5800;{EnSoniq 5800, Revision 02, Card says creative}
{CT4750 ,Revision ID-$02,"chip says creative ct5880"}


var CardDetected:boolean;

var high16,low16:word;
var TSRfound:byte;

 function dumbdelay:word;export;
 function deaddelay:word;export;
  function delay1(len:longint):word;export;



 procedure TSR_Check; export;
 function Detect137X:boolean;export;
 function Set1371MemoryPage(page:byte):boolean; export;
 function DAC1pause:byte; export;
 function DAC1unpause:byte; export;
 function Disablesamplerateconverter:boolean;export;
 function Enablesamplerateconverter:boolean;export;
 function getsamplerateconvertervalue(index:byte):word;export;
 function setsamplerateconvertervalue(index:byte;value:word):boolean;export;
 function codecbusy:boolean;
 function CODECready:boolean;
 function AC97CODECWrite(AC97IOport:word;AC97CODECreg:longint;setvalue:word):word;export;
 function ac97CODEC_Setvalue(code:byte;value:word):word;export;
  function son(id:byte):byte; export;
  function soff(id:byte):byte;export;
  function sixteenbit(id:byte):byte; export;
  function eightbit(id:byte):byte; export;
 procedure interruptdata(val:boolean); export;
 procedure DAClooping(id:byte;val:boolean); export;
 procedure DACon(id:byte;x:boolean);export;
 function mute:byte; export;
 function silence:byte;export;
 function unsilence:byte;export;
 function unmute:byte; export;
 procedure DAC1scro(x:boolean);export;
 function Configure137x(id:byte):boolean;export;
 function DACsoff:byte; export;


 function CTcreate:byte; export;
 function CTdesroy:byte; export;

 function setDAC1to44k:byte;
 function setDAC1to48k:byte;
implementation



procedure TSR_Check; assembler;
asm
        mov     ax, 0200h      { ; get real mode interrupt vector}
        mov     bl, 9Ah         {; our handler}
        int     31h             {; DPMI Call}

        or      cx, dx          {; anything there?}
        jz      @notsr
        mov     ax, 0       {; clear registers}
        mov     bx, 0
        mov     cx, 0
        int     9Ah             {; call int 60}

        cmp     cx, $1992       {; Signature: did it do it?}
        jnz     @notsr
        mov     TSRfound, 99
        mov     low16, ax
        mov     high16, bx
@notsr:
end;






function findunused1371card(si:word):byte;
var temp:Word;
begin
result:=0;temp:=0;
 if(detectPCIdevice(PCIcardDeviceID1,PCIcardVendor,PCIbus,PCIdevice,PCIfunc,si))then begin
  readPCIRegisterWord($3C,PCIbus,PCIdevice,PCIFunc,temp);
  if not(byte(temp)=0)then begin result:=1;writePCIRegisterWord($3C,PCIbus,PCIdevice,PCIFunc,0);end;
  end else begin
 end;
end;




function findunused5880card(si:word):byte;
var temp:word;
begin
result:=0;temp:=0;
if(detectPCIdevice(PCIcardDeviceID2,PCIcardVendor,PCIbus,PCIdevice,PCIfunc,si))then begin
 readPCIRegisterWord($3C,PCIbus,PCIdevice,PCIFunc,temp);
 if not(byte(temp)=0)then begin result:=2;writePCIRegisterWord($3C,PCIbus,PCIdevice,PCIFunc,0);end;
 end else begin

 end;
end;

function findunused5800card(si:word):byte;
var temp:word;
begin
result:=0;temp:=0;
 if(detectPCIdevice(PCIcardDeviceID3,PCIcardVendor,PCIbus,PCIdevice,PCIfunc,si))then begin
  readPCIRegisterWord($3C,PCIbus,PCIdevice,PCIFunc,temp);
  if not(byte(temp)=0)then begin result:=2;writePCIRegisterWord($3C,PCIbus,PCIdevice,PCIFunc,0);end;
  end else begin

 end;
end;


{Find,Enable and get I/O port}
function Detect137X:boolean;
var x:longint;
var temp:word;
var search:word;
var ret:byte;
var str:string;
var pl:byte;
begin
CardDetected:=false;
search:=0;
pl:=0;
pcibus:=0;
pcidevice:=0;
pcifunc:=0;
ret:=findunused1371card(search);{look for unused card}
if(ret=0)then begin pl:=pl+1;search:=search+1;ret:=findunused1371card(search);end else{no? search again}
if(ret=0)then begin pl:=pl+1;search:=search+1;ret:=findunused1371card(search);end else{no? search again}
if(ret=0)then begin pl:=pl+1;search:=search+1;ret:=findunused1371card(search);end else{no? search again}
if(ret=0)then begin pl:=pl+1;search:=search+1;ret:=findunused1371card(search);end;{no? search again}
search:=0;
if(ret=0)then begin pl:=pl+1;ret:=findunused5880card(search);end else{no? search again}
if(ret=0)then begin pl:=pl+1;search:=search+1;ret:=findunused5880card(search);end else{no? search again}
if(ret=0)then begin pl:=pl+1;search:=search+1;ret:=findunused5880card(search);end else{no? search again}
if(ret=0)then begin pl:=pl+1;search:=search+1;ret:=findunused5880card(search);end else{no? search again}
if(ret=0)then begin pl:=pl+1;search:=search+1;ret:=findunused5880card(search);end;{no? search again}
search:=0;
if(ret=0)then begin pl:=pl+1;ret:=findunused5800card(search);end else {no? search again}
begin {give up the search?} end;


{will set pci bus number}
{if(ret=1)then showmessage('found 1371'+inttostr(search));
if(ret=2)then showmessage('found 5880'+inttostr(search));
if(ret=0)then showmessage('found nothing'+inttostr(search));
}
mydrvoffset:=(pl*6);{8?}


 if(ret=1)then begin
 {The 1371 device}
 {now we have the BUS and Function numbers for the PCI card}
 {ens1371 detected! Is it already in use?}
  readPCIRegisterWord($3C,PCIbus,PCIdevice,PCIFunc,temp);

  drivername:='Creative es1371 (2015) '+inttostr(PCIfunc);
 {Enable the PCI card.}
  writePCIRegisterWord($4,PCIbus,PCIdevice,PCIFunc,$0105);

 {Obtain the PCI I/O port[] from the card.}
  readPCIRegisterword($10,PCIBUS,PCIdevice,PCIfunc,ens1371port);
  ens1371port:=ens1371port-1;
 {You can now use this port[ens1371port]}
  result:=true;

 {special RESET for the the CT5880 that says it is a 1371}
  x:=inport32(ens1371port+$4) ;
  ddret:=dumbdelay;
  outport32(ens1371port+$4,x or Bit29);
  ddret:=dumbdelay;


  CardDetected:=true;

 end else
 if(ret=2)then begin
 {The CT5880 device}
  drivername:='Creative CT5880 (2015) '+inttostr(PCIfunc);
 {now we have the BUS and Function numbers for the PCI card}
 {showmessage('Does a CT5880/ens1373 will work with this driver?');}
 {Enable the PCI card.}
  writePCIRegisterWord($4,PCIbus,PCIdevice,PCIFunc,$0105);

 {Obtain the PCI I/O port[] from the card.}
  readPCIRegisterword($10,PCIBUS,PCIdevice,PCIfunc,ens1371port);
  ens1371port:=ens1371port-1;
 {You can now use this port[ens1371port]}
  result:=true;
  ddret:=dumbdelay;  {special RESET for the the CT5880}
  x:=inport32(ens1371port+$4) ;
  ddret:=dumbdelay;
  outport32(ens1371port+$4,x or Bit29);
  ddret:=dumbdelay;
  CardDetected:=true;
 end else begin
 {ret=0}
 {showmessage('ens1371 not detected!');}
  drivername:='ens1371 not detected!';
  result:=false;
 end;

end;

{set ens137X memory page}
function Set1371MemoryPage(page:byte):boolean; begin
 port[ens1371port+MemoryPageSwap]:=(page and $F);
end;


function Disablesamplerateconverter:boolean;
var temp:longint;
var str:string;
begin
 temp:=inport32(ens1371port+Sample_rate_converter);
 temp:=temp or (Bit19+Bit20+Bit21+Bit22);{Disable all sources}
 {disable recording=bit19}
 {disable channel0=bit20}
 {disable channel1=bit21}
 outport32(ens1371port+Sample_rate_converter,temp);
 samcon:=false;
end;

function Enablesamplerateconverter:boolean;
var temp:longint;
begin
{enable all sources and disable write bit}
 temp:=inport32(ens1371port+Sample_rate_converter);
 temp:=inport32(ens1371port+Sample_rate_converter) and not(Bit24+Bit22+Bit20+Bit21{+Bit19});
 outport32(ens1371port+Sample_rate_converter,temp);
 samcon:=true;
{  sample rate converter disable=$22
  chan1 disable=bit21
  chan2 disable=bit20
 record disable=bit19}
end;



function getsamplerateconvertervalue(index:byte):word;
var temp:longint;
var x,y:byte;
begin
result:=0;

{check busy bit}
temp:=inport32(ens1371port+Sample_rate_converter);
y:=0;
while (y<$20)and((temp and Bit23)=Bit23) do begin
 y:=y+1;
 temp:=inport32(ens1371port+Sample_rate_converter);
end;
if(y=$20)then begin showmessage('sample rate converter was busy '+inttostr(y)+' times!');end;

{temp:=temp and not $FFFF; clear data bits}
{temp:=temp and not $FE00FFFF; clear source bits}
temp:=temp and not $FE00FFFF;{clear source and data bits}
temp:=(temp or Bit19 or Bit20 or Bit21 or Bit22);{Disable all sources}
temp:=temp and not BIT24;{clear write bit}
temp:=temp or (longint((index {and $7F})) shl 25);{set register to read}
{write the data address and read data request}
outport32(ens1371port+Sample_rate_converter,temp);

{make sure it is still ready to read}
temp:=inport32(ens1371port+Sample_rate_converter);
 if((temp and Bit23)=Bit23)then begin{BIt23 is busy bit}
  {dumbdelay;}
  deaddelay;{add back if not working}
  temp:=inport32(ens1371port+Sample_rate_converter);
 end;

{return the data}
{temp:=temp and $FFFF;}
result:=word(temp);

end;





function setsamplerateconvertervalue(index:byte;value:word):boolean;
var temp:longint;
var x,y:byte;
var str:string;
begin
result:=false;

{check busy bit}
temp:=inport32(ens1371port+Sample_rate_converter);
y:=0;
while (y<$20)and((temp and Bit23)=Bit23) do begin
 y:=y+1;
 temp:=inport32(ens1371port+Sample_rate_converter);
end;
if(y=$20)then begin showmessage('sample rate converter was busy '+inttostr(y)+' times!');end;

{temp:=temp and not $FFFF; clear data bits}
{temp:=temp and not $FE00FFFF; clear source bits}
temp:=temp and not $FE00FFFF;{clear source and data bits}
temp:=(temp or Bit19 or Bit20 or Bit21 or Bit22);{Disable all sources}
temp:=temp or BIT24;{set write bit}
temp:=temp or (longint((index {and $7F})) shl 25);{set register to write}
temp:=temp or value;{value to write}
{write the data}
outport32(ens1371port+Sample_rate_converter,temp);

{clear write bit}
temp:=temp and not BIT24;{clear write bit}
outport32(ens1371port+Sample_rate_converter,temp);

{check status}

temp:=inport32(ens1371port+Sample_rate_converter) and $FFFF;
if not(temp=value)then begin
showmessage('Sample rate converter busy!');
end;
end;



function codecbusy:boolean;
var x:longint;
begin
result:=false;
x:=inport32(ens1371port+$14);
 if((x and (Bit30))=Bit30)then begin
  {WIP Work in progress}
  {showmessage('working hard!');}
  result:=true;
 end;
end;

function CODECready:boolean;
var x:longint;
begin
result:=false;
x:=inport32(ens1371port+$14);
 if ((x and (Bit31))=Bit31)then begin
  {RDY Ready}
  result:=true;
 end;
end;

function ac97CODEC_Setvalue(code:byte;value:word):word;
begin
 result:=AC97CODECWrite(ens1371port+AC97CODEC,code,value);
end;

function soff(id:byte):byte;
var tb:word;
begin
tb:=id * 2;
{turn stereo off}
 portw[ens1371port+$20]:=portw[ens1371port+$20] and  not (Stereo_Bit shl tb);
end;


function son(id:byte):byte;
var tb:word;
begin
tb:=id * 2;
{turn stereo on}
 portw[ens1371port+$20]:=portw[ens1371port+$20] or (Stereo_Bit shl tb);
end;

function eightbit(id:byte):byte;
var tb:word;
begin
tb:=id * 2;
{temp:=not Bit0;}
 portw[ens1371port+$20]:=portw[ens1371port+$20] and not (Sixteen_Bit shl tb);
end;

function sixteenbit(id:byte):byte;
var was:boolean;
var tb:word;
begin
tb:=id * 2;
 portw[ens1371port+$20]:=portw[ens1371port+$20] or (Sixteen_Bit shl tb);
end;

{set dac1 loop/stop}
procedure DAClooping(id:byte;val:boolean);
var temp:longint;
begin
 if(val=true)then begin
  temp:=portw[ens1371port+$20] and not (Bit13 shl id);
  portw[ens1371port+$20]:=temp;
 end else begin
  temp:=portw[ens1371port+$20] or (Bit13 shl id);
  portw[ens1371port+$20]:=temp;
 end;
end;

{turn interrupt data on}
procedure interruptdata(val:boolean);
begin
 if(val=true)then begin
  portw[ens1371port+$20]:=portw[ens1371port+$20] or Bit8;
 end else begin
  portw[ens1371port+$20]:=portw[ens1371port+$20] and not Bit8;
 end;
end;

procedure DACon(id:byte;x:boolean);
begin
 if(x=true)then begin
  port[ens1371port]:=port[ens1371port] or (Bit6 shr id);
 end else begin
  port[ens1371port]:=port[ens1371port] and not (Bit6 shr id);
 end;
end;

function DACsoff:byte; begin
 port[ens1371port]:=0;
end;


procedure DAC1scro(x:boolean);begin
 portw[ens1371port+$20]:=portw[ens1371port+$20] xor Bit7;
 portw[ens1371port+$20]:=portw[ens1371port+$20] xor Bit7;
end;

function DAC1pause:byte;
var x:word;
begin
 x:=portw[ens1371port+$20] and not BIT11;
 portw[ens1371port+$20]:=x;
end;

function DAC1unpause:byte;
var x:word;
begin
 x:=portw[ens1371port+$20] and Bit11;
 portw[ens1371port+$20]:=x;
end;

function AC97CODECWrite(AC97IOport:word;AC97CODECreg:longint;setvalue:word):word;
var w,x,y:longint;
begin

 for y:=0 to 10 do begin
  if(codecbusy)then begin ddret:=delay1($FFFF);end;{hello ?}
 end;
if(codecbusy)then begin showmessage('error!');end;

x:=setvalue+(AC97CODECreg shl 16);{write register}
outport32(AC97IOport,(x));{write ac97 register}
end;

function mute:byte; begin
{mute the volume}
 ac97CODEC_Setvalue(AC97_MASTER_VOLUME,$FFFF);
{mymute:=1;}
end;

function silence:byte;
var novol:longint;
var a,b:word;
var x:word;
begin
novol:=myvol;
a:=hiword(novol);
b:=loword(novol);
x:=0;
showmessage('silence!');
 while x<16 do begin
  if a>1 then begin a:=a shr 1;end;
  if b>1 then begin b:=b shr 1;end;
  {reduce the volume slowly}
  ac97CODEC_Setvalue(AC97_MASTER_VOLUME,(
  (($1f-(A div $800)) and $1f) shl 8)+
  (($1f-(B div $800)) and $1f)
  );
  x:=x+1;
 end;
showmessage('silence complete!');
result:=0;
end;



function unsilence:byte;
var a,b,x,y:word;
var zd:integer;
begin
a:=hiword(myvol);x:=0;
b:=loword(myvol);y:=0;

zd:=0;
while zd>16 do begin
 showmessage('z='+inttostr(zd)+'&'+'x='+inttostr(x));
 if a>x then begin x:=a-word(a shr zd);end;
 if b>y then begin y:=b-word(b shr zd);end;
 {reduce the volume slowly}

 ac97CODEC_Setvalue(AC97_MASTER_VOLUME,(
 (($1f-(x div $800)) and $1f) shl 8)+
 (($1f-(y div $800)) and $1f)
 );
 zd:=zd+1;
end;

result:=0;
end;



function unmute:byte; begin
{Restore the Volume}
 ac97CODEC_Setvalue(AC97_MASTER_VOLUME,(
 (($1f-(hiword(myvol) div $800)) and $1f) shl 8)+
 (($1f-(loword(myvol) div $800)) and $1f)
 );
{mymute:=0;}
end;


function dumbdelay:word;
var x,y:longint;
begin
result:=1;
 for x:=0 to $FFF0 do begin
  application.processmessages;
  y:=x;
 end;
result:=0;
end;


function deaddelay:word;
var x,y:word;
begin
 for x:=0 to $FF0 do begin
  y:=x;
 end;
result:=0;
end;


function delay1(len:longint):word;
var x,y,z:longint;
begin
 for x:=0 to len do begin
  y:=x;
  if(y=x)then begin z:=y;end;
 end;
result:=word(z);
end;



procedure clearallbuffersN(val:byte); begin
fillchar(LMB^,word($FFFF),char(val));{clear the sound data p0}
HugeInc(pointer(LMB),$FFFF);{forward a page}
fillchar(LMB^,word($FFFF),char(val));{clear the sound data p1}
HugeDec(pointer(LMB),$FFFF);{back a page}
end;


function Configure137x(id:byte):boolean;
var temp:longint;
var str:string;
var myini:tinifile;
var baddr:longint;
begin

DACid:=0;
{Toggle -Warm reset-}
{set reset bit}
portw[ens1371port]:=portw[ens1371port] or Bit14;
portw[ens1371port]:=portw[ens1371port] xor Bit14;

{Set the -DAC1 Memory Location-}
Set1371MemoryPage($c);{change to proper memory page}
 baddr:=longint(mem1.physical)+dataoffset;
outport32(ens1371port+$30,(baddr{mydrvoffset * $10000}));{Point DAC1 to your preferred memory location}
outport32(ens1371port+$34,$2000-1);{Set DAC1 play time}

{Set the -DAC2 Memory Location- just in case...}
Set1371MemoryPage($c);{change to proper memory page}
outport32(ens1371port+$38,(baddr{mydrvoffset * $10000}));{Point DAC2 to your preferred memory location}
outport32(ens1371port+$3C,$2000-1);{Set DAC2 play time}

{Turn DAC1 ON}
{port[ens1371port]:=port[ens1371port] or Bit6;
dumbdelay;}
DACon(id,true);

{Before adjusting settings,}
{Disable the -Sample Rate Converter-}
Disablesamplerateconverter;
dumbdelay;


myini:=tinifile.create(ininame);

{Set the volume DAC1}
 str:=myini.readstring('PCI','SR_DAC1_LVOL','no');
 if(str='no')then begin temp:=$1010;myini.writestring('PCI','SR_DAC1_LVOL','$1010');end else begin temp:=strtoint(str);end;
 setsamplerateconvertervalue(SR_DAC1_LVOL,temp);
 setsamplerateconvertervalue(SR_DAC1_RVOL,temp);


{Set the volume DAC2}
 str:=myini.readstring('PCI','SR_DAC2_LVOL','no');
 if(str='no')then begin temp:=$1010;myini.writestring('PCI','SR_DAC2_LVOL','$1010');end else begin temp:=strtoint(str);end;
 setsamplerateconvertervalue(SR_DAC2_LVOL,temp);
 setsamplerateconvertervalue(SR_DAC2_RVOL,temp);




{Play with data rate settings}

temp:=8 shl 10;{vfi was}
 setsamplerateconvertervalue(SR_DAC1_Trunc_and_N,$0100);
 setsamplerateconvertervalue(SR_DAC1_VFI_ACI,$3800);
 setsamplerateconvertervalue(SR_DAC1_ACC,$0000);
 setsamplerateconvertervalue(SR_DAC1_VFreq,$5666);{DAC1 44100hz?}

 setsamplerateconvertervalue(SR_DAC2_Trunc_and_N,$0100);
 setsamplerateconvertervalue(SR_DAC2_VFI_ACI,$3800);
 setsamplerateconvertervalue(SR_DAC2_ACC,$0000);
 setsamplerateconvertervalue(SR_DAC2_VFreq,$5666);{DAC2 44100hz?}

setsamplerateconvertervalue(SR_ADC_Trunc_and_N,$0100);
setsamplerateconvertervalue(SR_ADC_VFI_ACI,$0C00);
setsamplerateconvertervalue(SR_ADC_VFreq,0);{ADC 11025?}




{Turn on the -AC97 CODEC-}
ac97CODEC_Setvalue(AC97_RESET,0);{Reset the AC97}
{showmessage('ac97!');}

str:=myini.readstring('AC97','PCM_VOLUME','no');
if(str='no')then begin temp:=$0202;myini.writestring('AC97','PCM_VOLUME','$0202');end else begin temp:=strtoint(str);end;
{0000=loud}
 ac97CODEC_Setvalue(AC97_PCM_VOLUME,temp);{Set AC97 PCM volume}
 myvol:=$30003000;



 str:=myini.readstring('sound','myvol','$10001000');
 myvol:=strtoint(str);


{Set the Volume
ac97CODEC_Setvalue(AC97_MASTER_VOLUME,(
(($1f-(hiword(myvol) div $800)) and $1f) shl 8)+
(($1f-(loword(myvol) div $800)) and $1f)
);}

str:=myini.readstring('AC97','MASTER_VOLUME','no');
if(str='no')then begin temp:=$0202;myini.writestring('AC97','MASTER_VOLUME','$0202');end else begin temp:=strtoint(str);end;
 ac97CODEC_Setvalue(AC97_MASTER_VOLUME,temp);{Set AC97 Master volume}
 ac97CODEC_Setvalue(AC97_LINEINPUT_VOLUME,$0202);{Set AC97 line input}
 ac97CODEC_Setvalue(AC97_CD_VOLUME,$0202);{Set AC97 CD volume}

myini.free;

DAClooping(DACid,true);interruptdata(true);{play sounds only once}

{showmessage('clear data!');}
{fillchar(buffer^,word($FFFF),char(0));{clear the sound data}
{clearallbuffersN(nilfil);{}

{Enable the -Sample Rate Converter- to hear sounds.}

son(DACid);{stereo}
sixteenbit(DACid);
Enablesamplerateconverter;
end;


function setDAC1to44k:byte;
begin
{ if(freq=44100)and(spk=stereo)then begin}
 setsamplerateconvertervalue(SR_DAC1_Trunc_and_N,$0100);
 setsamplerateconvertervalue(SR_DAC1_VFI_ACI,$3800);
 setsamplerateconvertervalue(SR_DAC1_ACC,$0000);
 setsamplerateconvertervalue(SR_DAC1_VFreq,$5666);{44100hz?}
 son(DACid);
 sixteenbit(DACid);
end;

function setDAC1to48k:byte;
begin
{ if(freq=48000)and(spk=stereo)then begin}
 setsamplerateconvertervalue(SR_DAC1_Trunc_and_N,$0100);
 setsamplerateconvertervalue(SR_DAC1_VFI_ACI,$4002);
 setsamplerateconvertervalue(SR_DAC1_ACC,$0000);
 setsamplerateconvertervalue(SR_DAC1_VFreq,$0000);{48000hz?}
 son(DACid);
 sixteenbit(DACid);
end;




function CTcreate:byte;
var myini:tinifile;
begin
 if(CTactive=false)then begin
 CTactive:=true;
  TSR_Check;
   IF(TSRfound=99) then begin{TSR was found?}
    mem1.physical:=pointer(makelong(low16,high16));{memory location}
   end else begin
    mem1.physical:=pointer(defaultaddr);{memory location}
   end;
  mem1.length:=pointer(totalspace or $FFFFF {dataoffset+(blocksiz*blocks)}{200000});
  allocateLMB(mem1);{
  sgd:=0;
  sgdindex:=0; }
 end;

 IF(TSRfound=99) then begin{TSR was found?}
   myini:=tinifile.create(ininame);
    myini.writestring('TSR','XMS','Found');
    myini.writestring('BUSMASTER','myPCIHI','$'+inttohex(high16,4));
    myini.writestring('BUSMASTER','myPCILO','$'+inttohex(low16,4));
    myini.writestring('BUSMASTER','myPCImem','$'+inttohex(makelong(low16,high16),8));
   myini.free;
  myPCIhi:=high16;
  myPCIlo:=low16;
  myPCImem:=makelong(low16,high16);
end else begin{TSR was not found}
 myini:=tinifile.create(ininame);
  myini.writestring('TSR','XMS','Not Found');
  myPCIHI:=strtoint(myini.readstring('BUSMASTER','myPCIHI',inttostr(defmyPCIHI)));
  myPCILO:=strtoint(myini.readstring('BUSMASTER','myPCILO',inttostr(defmyPCILO)));
  myPCImem:=strtoint(myini.readstring('BUSMASTER','myPCImem',inttostr(defmyPCImem)));
 myini.free;
end;


end;

function CTdesroy:byte; begin
 if(CTactive=true)then begin
  clearallbuffersN(nilfil);{}
{  port[IOPORTBAR+0{SGD]:=$00;{Stop playing sounds}
  freeLMB(mem1);
  CTactive:=false;
 end;
end;



end.
