unit Mmddk;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  limits,mmsystem,forms,inifiles,tintlist, Dialogs, StdCtrls, Buttons;



{common constants}
{const Bit:array[0..7] of byte=(1,2,4,8,16,32,64,128);}
const BIT0=1;
const BIT1=2;
const BIT2=4;
const BIT3=8;
const BIT4=$10;
const BIT5=$20;
const BIT6=$40;
const BIT7=$80;
const BIT8=$100;
const BIT9=$200;
const BIT10=$400;
const BIT11=$800;
const BIT12=$1000;
const BIT13=$2000;
const BIT14=$4000;
const BIT15=$8000;
const BIT16=$10000;
const BIT17=$20000;
const BIT18=$40000;
const BIT19=$80000;
const BIT20=$100000;
const BIT21=$200000;
const BIT22=$400000;
const BIT23=$800000;
const BIT24=$1000000;
BIT25=$2000000;
BIT26=$4000000;
BIT27=$8000000;
BIT28=$10000000;
BIT29=$20000000;
BIT30=$40000000;
BIT31=$80000000;





{mmsystem}

const{mmsystem}
  CallBack_TypeMask   = $00070000;    { callback type mask }
  CallBack_Null       = $00000000;    { no callback }
  CallBack_Window     = $00010000;    { dwCallback is a HWND }
  CallBack_Task       = $00020000;    { dwCallback is a HTASK }
  CallBack_Function   = $00030000;    { dwCallback is a FARPROC }

{ flags for dwFlags parameter in waveOutOpen() and waveInOpen() }
const  wave_Format_Query     = $0001;
const  wave_AllowSync        = $0002;
const
  MaxPNameLen      =  32;    { max product name length (including NULL) }


{flags for dwSupport field of WAVEOUTCAPS }

const WAVECAPS_PITCH =        $0001;  { supports pitch control }
const WAVECAPS_PLAYBACKRATE = $0002;   { supports playback rate control }
const WAVECAPS_VOLUME        =$0004;   { supports volume control }
const WAVECAPS_LRVOLUME      =$0008;   { separate left-right volume control }
const WAVECAPS_SYNC          =$0010;

type
  TWaveOutCaps = record
    wMid: Word;                 { manufacturer ID }
    wPid: Word;                 { product ID }
    vDriverVersion: word;       { version of the driver }
    szPname: array[0..MaxPNameLen-1] of Char;  { product name (NULL terminated string) }
    dwFormats: Longint;          { formats supported }
    wChannels: Word;            { number of sources supported }
    dwSupport: Longint;          { functionality supported by driver }
  end;
  PWaveOutCaps = ^TWaveOutCaps;

const
  mm_Microsoft            = 1;       { Microsoft Corp. }

{ product IDs }
  mm_MIDI_Mapper          = 1;       { MIDI Mapper }
  mm_Wave_Mapper          = 2;       { Wave Mapper }

  mm_SndBlst_MidiOut      = 3;       { Sound Blaster MIDI output port }
  mm_SndBlst_MidiIn       = 4;       { Sound Blaster MIDI input port  }
  mm_SndBlst_Synth        = 5;       { Sound Blaster internal synthesizer }
  mm_SndBlst_WaveOut      = 6;       { Sound Blaster waveform output }
  mm_SndBlst_WaveIn       = 7;       { Sound Blaster waveform input }

  mm_Adlib                = 9;       { Ad Lib-compatible synthesizer }

  mm_MPU401_MidiOut       = 10;      { MPU401-compatible MIDI output port }
  mm_MPU401_MidiIn        = 11;      { MPU401-compatible MIDI input port }

  mm_PC_Joystick          = 12;      { Joystick adapter }

const
  wave_InvalidFormat     = $00000000;       { invalid format }

  wave_Format_1M08       = $00000001;       { 11.025 kHz, Mono,   8-bit  }
  wave_Format_1S08       = $00000002;       { 11.025 kHz, Stereo, 8-bit  }
  wave_Format_1M16       = $00000004;       { 11.025 kHz, Mono,   16-bit }
  wave_Format_1S16       = $00000008;       { 11.025 kHz, Stereo, 16-bit }

  wave_Format_2M08       = $00000010;       { 22.05  kHz, Mono,   8-bit  }
  wave_Format_2S08       = $00000020;       { 22.05  kHz, Stereo, 8-bit  }
  wave_Format_2M16       = $00000040;       { 22.05  kHz, Mono,   16-bit }
  wave_Format_2S16       = $00000080;       { 22.05  kHz, Stereo, 16-bit }

  wave_Format_4M08       = $00000100;       { 44.1   kHz, Mono,   8-bit  }
  wave_Format_4S08       = $00000200;       { 44.1   kHz, Stereo, 8-bit  }
  wave_Format_4M16       = $00000400;       { 44.1   kHz, Mono,   16-bit }
  wave_Format_4S16       = $00000800;       { 44.1   kHz, Stereo, 16-bit }

  wave_Format_8M08       = $00001000;       { X   kHz, Mono,   8-bit  }
  wave_Format_8S08       = $00002000;       { X   kHz, Stereo, 8-bit  }
  wave_Format_8M16       = $00004000;       { X   kHz, Mono,   16-bit }
  wave_Format_8S16       = $00008000;       { X   kHz, Stereo, 16-bit }

{ types for wType field in MMTIME struct }
const
  time_MS         = $0001;  { time in milliseconds }
  time_Samples    = $0002;  { number of wave samples }
  time_Bytes      = $0004;  { current byte offset }
  time_SMPTE      = $0008;  { SMPTE time }
  time_MIDI       = $0010;  { MIDI time }


{ MMTIME data structure }
type
  PMMTime = ^TMMTime;
  TMMTime = record
    case wType: Word of        { indicates the contents of the variant record }
     time_MS : (ms: Longint);
     time_Samples : (sample: Longint);
     time_Bytes : (cb: Longint);
     time_SMPTE : (
        hour: Byte;
        min: Byte;
        sec: Byte;
        frame: Byte;
        fps: Byte;
        dummy: Byte);
      time_MIDI : (songptrpos: Longint);
  end;


{ Auxiliary audio device capabilities structure }
type
  PAuxCaps = ^TAuxCaps;
  TAuxCaps = record
    wMid: Word;                  { manufacturer ID }
    wPid: Word;                  { product ID }
    vDriverVersion: word;        { version of the driver }
    szPname: array[0..MaxPNameLen-1] of Char;  { product name (NULL terminated string) }
    wTechnology: Word;           { type of device }
    dwSupport: Longint;             { functionality supported by driver }
  end;
{ flags for wTechnology field in AUXCAPS structure }
const
  auxcaps_CDAudio    = 1;       { audio from internal CD-ROM drive }
  auxcaps_AuxIn      = 2;       { audio from auxiliary input jacks }

{ flags for dwSupport field in AUXCAPS structure }
const
  auxcaps_Volume     = $0001;  { supports volume control }
  auxcaps_LRVolume   = $0002;  { separate left-right volume control }



{ wave data block header }
type
  PWaveHdr = ^TWaveHdr;
  TWaveHdr = record
    lpData: longint;                {lpWaveData   pointer to locked data buffer }
    dwBufferLength: Longint;      {length of data buffer }
    dwBytesRecorded: Longint;     {used for input only }
    dwUser: Longint;              {dwWaveUser   for client's use }
    dwFlags: Longint;             {dwWaveFlags  assorted flags (see defines) }
    dwLoops: Longint;             {dwWaveLoops  loop control counter }
    lpNext: Longint{PWaveHdr};             {lpWaveNext   reserved for driver }
    reserved: Longint;            {Wavereserved reserved for driver }
    {lpnext remebers the next wavehdr}
    {reserved remembers the dwuser}
  end;

{min length is one twavehdr check total size and lpNext}


{ flags for dwFlags field of WAVEHDR }
const
  whdr_Done       = $00000001;  { done bit }
  whdr_Prepared   = $00000002;  { set if this header has been prepared }
  whdr_BeginLoop  = $00000004;  { loop start block }
  whdr_EndLoop    = $00000008;  { loop end block }
  whdr_InQueue    = $00000010;  { reserved for driver }


{ waveform output }
const
  mm_WOM_Open         = $3BB;
  mm_WOM_Close        = $3BC;
  mm_WOM_Done         = $3BD;

{ wave callback messages }
const
  wom_Open        = mm_WOM_Open;
  wom_Close       = mm_WOM_Close;
  wom_Done        = mm_WOM_Done;



const WAVERR_BASE =32;
const WAVERR_BADFORMAT       =(WAVERR_BASE + 0);    { unsupported wave format}
const  WAVERR_STILLPLAYING   =(WAVERR_BASE + 1);    { still something playing}
const  WAVERR_UNPREPARED     =(WAVERR_BASE + 2);    { header not prepared    }
const  WAVERR_SYNC           =(WAVERR_BASE + 3);    { device is synchronous  }
const  WAVERR_LASTERROR      =(WAVERR_BASE + 3);    { last error in range    }

const  MMSYSERR_BASE         =0;
const  MMSYSERR_NOERROR      =0;                     {no error }
const  MMSYSERR_ERROR        =(MMSYSERR_BASE + 1);   {unspecified error}
const  MMSYSERR_BADDEVICEID  =(MMSYSERR_BASE + 2);   {device ID out of range}
const  MMSYSERR_NOTENABLED   =(MMSYSERR_BASE + 3);   {driver failed enable}
const  MMSYSERR_ALLOCATED    =(MMSYSERR_BASE + 4);   {device already allocated}
const  MMSYSERR_INVALHANDLE  =(MMSYSERR_BASE + 5);   {device handle is invalid}
const  MMSYSERR_NODRIVER     =(MMSYSERR_BASE + 6);   {no device driver present}
const  MMSYSERR_NOMEM        =(MMSYSERR_BASE + 7);   {memory allocation error}
const  MMSYSERR_NOTSUPPORTED =(MMSYSERR_BASE + 8);   {function isn't supported}
const  MMSYSERR_BADERRNUM    =(MMSYSERR_BASE + 9);  {error value out of range}
const  MMSYSERR_INVALFLAG    =(MMSYSERR_BASE + 10);  {invalid flag passed}
const  MMSYSERR_INVALPARAM   =(MMSYSERR_BASE + 11);  {invalid parameter passed}
const  MMSYSERR_LASTERROR    =(MMSYSERR_BASE + 11);  {last error in range}


{ general waveform format structure (information common to all formats) }
type
  PWaveFormat = ^TWaveFormat;
  TWaveFormat = record
    wFormatTag: Word;         { format type }
    nChannels: Word;          { number of channels (i.e. mono, stereo, etc.) }
    nSamplesPerSec: Longint;  { sample rate }
    nAvgBytesPerSec: Longint; { for buffer estimation }
    nBlockAlign: Word;      { block size of data }
  end;

{ flags for wFormatTag field of WAVEFORMAT }
const
  wave_Format_PCM     = 1;

{ specific waveform format structure for PCM data }
type
  PPCMWaveFormat = ^TPCMWaveFormat;
  TPCMWaveFormat = record
      wf: TWaveFormat;
      wBitsPerSample: Word;
   end;


{end mmsystem}




{      Helper functions for drivers        }
const
DCB_NOSWITCH    =   $0008; {don't switch stacks for callback}
DCB_TYPEMASK    =   $0007; {callback type mask}
DCB_NULL        =   $0000; {unknown callback type}

{ flags for wFlags parameter of DriverCallback()}
DCB_WINDOW     =    $0001; {dwCallback is a HWND}
DCB_TASK       =    $0002; {dwCallback is a HTASK}
DCB_FUNCTION   =    $0003; {dwCallback is a FARPROC}



const MAXWAVEDRIVERS =10;{maximum number of wave device drivers loaded}



type  WAVEOPENDESC=record
    hWave:word;             { handle "hwave"}
    LPWAVEFORMAT:pWAVEFORMAT;  { format of wave data }
    Callback:longint;      { callback }
    Instance:longint;      { app's private instance information }
end;
type pWAVEOPENDESC =^WAVEOPENDESC;


const DRVM_USER             =$4000;

{
 * Message sent by mmsystem to wodMessage(), widMessage(), modMessage(),
 * and midMessage() when it initializes the wave and midi drivers
 }

const  DRVM_INIT  =100;
const  WODM_INIT  =DRVM_INIT;
const  WIDM_INIT  =DRVM_INIT;
const  MODM_INIT  =DRVM_INIT;
const  MIDM_INIT  =DRVM_INIT;
const  AUXM_INIT  =DRVM_INIT;

{ messages sent to wodMessage() entry-point function }
const  WODM_GETNUMDEVS     =3;{Must give}
const  WODM_GETDEVCAPS     =4;{Must give}
const  WODM_OPEN  	   =5;{must open}
const  WODM_CLOSE 	   =6;{must close}

{don't have to prepare anything}
const  WODM_PREPARE        =7;
const  WODM_UNPREPARE      =8;

const  WODM_WRITE 	   =9;{must write}
const  WODM_PAUSE  	   =10;{a}
const  WODM_RESTART        =11;{b}
const  WODM_RESET 	   =12;{c}
const  WODM_GETPOS	   =13;{d}
{const  WODM_GETPITCH       =14;
const  WODM_SETPITCH       =15;}
const  WODM_GETVOLUME      =16;
const  WODM_SETVOLUME      =17;
{const  WODM_GETPLAYBACKRATE=18;
const  WODM_SETPLAYBACKRATE=19;}
const  WODM_BREAKLOOP      =20;

{ messages sent to widMessage() entry-point function }
{
const  WIDM_GETNUMDEVS  =50;
const  WIDM_GETDEVCAPS  =51;
const  WIDM_OPEN        =52;
const  WIDM_CLOSE       =53;
const  WIDM_PREPARE     =54;
const  WIDM_UNPREPARE   =55;
const  WIDM_ADDBUFFER   =56;
const  WIDM_START       =57;
const  WIDM_STOP        =58;
const  WIDM_RESET       =59;
const  WIDM_GETPOS      =60;
                 }

{maximum number of auxiliary device drivers loaded}
const MAXAUXDRIVERS=10;
{messages sent to auxMessage() entry-point function}
const AUXDM_GETNUMDEVS=3;
const AUXDM_GETDEVCAPS=4;
const AUXDM_GETVOLUME =5;
const AUXDM_SETVOLUME =6;

{ FIXED PRELOAD SINGLE PRELOAD}

{tell mmsystem goonball function what to do}
type TMmsystem_DriverCallback=function (dwCallback:longint;uflags:word;
     hdevice:word;uMessage:word;dwUser,lparam1:longint;wParam2:longint):boolean;




{export wodMessage      @2}
{you could import it}
type sounddevmsgproc =
     function (wDeviceID,wMessage:word;Instance,lparam1,lparam2:longint):longint;


{DriverProc      @1}
type aDriverProcproc =
     function (DriverIdentifier: Longint; DriverId: THandle;Msg: Word; lParam1, lParam2: Longint): Longint;



var drivername:string;

const Stereo_Bit=Bit0;
const Sixteen_Bit=Bit1;


{Windows selector for Memory location above 4mb}
type tlp=^ptla;
ptla=record
test:array[0..$FFF0] of byte;
end;

Type
wstr = ^wIstr;
wIstr = Record
test:array[0..$FFF0 div 2]of word;     {//words of data}
end;

Type
istr = ^iria;
iria = Record
test:array[0..$FFF0 div 2]of integer;     {//words of data}
end;


type
  Twavealloc = record
    LCallback: longint; {client's callback}
    LInstance: longint; {client's instance data}
    hWave: word;         {handle for stream}
    LFlags:longint;     {allocation flags}
    LByteCount: Longint; {bytecount}
    pcmwf: TPCMWAVEFORMAT; {formtat of wave data}
  end;
 Pwavealloc = ^TWavealloc;
const WHDR_REALLYDONE=$80000000; {My internal driver flag for wave headers }

Type mydevice=record
enabled:boolean;
opened:longint;
userinfo:Twavealloc;
ptempclient:pointer;
wav:tmemorystream;{input}
output:pointer;
paused:byte;
volume:longint;
pos:longint;
maxpos:longint;
realpos:longint;
written:tintegerlist;
wavDesc:waveopendesc;
loops:longint;
bits:byte;
nbytes:byte;
channels:word;
blockalign:word;
samplespersec:longint;
inc:longint;
waveformat:twaveformat;
woc:TWAVEOUTCAPS;
lp1store:longint;
lp2store:longint;
stop:byte;
synchronous:boolean;
wiz:longint;
empty:boolean;
over:byte;

end;

const maxinque=8000;
var drvenabled:boolean;
const maxdevices=totmax;{zero is one device}
var WOD:array[0..maxdevices] of mydevice;


{var bhalf:longint;}

{var lop:longint;
lofs:longint;
bsize:longint;
{}
{var wodEnabled:boolean;}
{var sync:boolean;}
{var myvol:longint;}
{var myinc:longint;}
{var myblockalign:word;}
{var mychannels,mybits,mySamplesPerSec:longint;}
{var myWD:waveopendesc;}
{var mywaveformat:tWAVEFORMAT;}
{var lpstore:array[1..3] of longint;}
{var mywavehdr:twavehdr;}
{var opened:longint;}
{var toto:longint;}
{var written:tintegerlist;}
{var mypos:longint;
var mymaxpos:longint;
var myrealpos:longint;}
{var mypaused:word;}
{var wiz:longint;}
{var myuser:longint;}
{var myloops:longint;}
{var mystop:byte;}


implementation




end.
