{ ************************************************************************ }
{ PCI.PAS:  PCI BIOS Routines by Dieter R. Pawelczak <dieterp@bigfoot.de>  }
{ ======================================================================== }
{                                                                          }
{              Unit to detect PCI-Devices and to read/write to             }
{              its configuration registers                                 }
{                                                                          }
{ (c) 1998 by Dieter Pawelczak, <dieterp@bigfoot.de>                       }
{ This is public domain Software - selling this software is prohibeted!    }
{                                                                          }
{ ************************************************************************ }

{$G+}


unit PCI;
interface

function detectPCIBios:boolean;
function detectPCIdevice(DeviceID:Word;VendorID:Word;
VAR BusNumber:Byte;VAR DeviceNumber:Byte;VAR FunctionNumber:Byte;searchstart:word):boolean;
function readPCIRegisterByte(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;var resulty:byte):boolean;
function readPCIRegisterWord(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;var resulty:Word):boolean;
function readPCIRegisterDWord(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;var resulty:longint):boolean;
function writePCIRegisterByte(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;input:byte):boolean;
function writePCIRegisterWord(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;input:word):boolean;
function writePCIRegisterDWord(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;input:longint):boolean;
function MMIOBARSIZE32(reg:word;Bus,Dev,Func:Byte):longint;export;
function inport32(portnum:word):longint;
procedure outport32(portnum:word;value:longint);
implementation

{wat say?}
function inport32(portnum:word):longint;begin
asm
mov dx,portnum
db 66h; in ax,dx;{in eax,edx}
db 66h; mov word ptr result,ax{mov var,eax}
end;
end;
{wat say?}
procedure outport32(portnum:word;value:longint);begin
asm
mov dx,portnum
db 66h; mov ax, word ptr value  { mov eax, ... }
db 66h; out dx,ax               { out dx,eax  }
end;
end;


function detectPCIBios:boolean;assembler;
asm
    mov ax,0b101h
    int 1ah
    jc @nopcibios
    mov ax,1
    ret
  @nopcibios:
    xor ax,ax
    ret
end;

function detectPCIdevice(DeviceID:Word;VendorID:Word;
VAR BusNumber:Byte;VAR DeviceNumber:Byte;VAR FunctionNumber:Byte;searchstart:word):boolean;
var found:boolean;
    bn:byte;
    fn:byte;
begin
  bn:=0;fn:=0;
  found:=false;
  asm
    db 66h;pusha
    mov cx,DeviceID
    mov dx,VendorID
    mov ax,0b102h
    mov si,searchstart
    int 1ah
    jc @nodevice
    mov found,true
    mov bn,BH
    mov fn,BL
  @nodevice:
    db 66h;popa
  end;
  BusNumber:=bn;DeviceNumber:=fn shr 3;FunctionNumber:=fn and $7;
  detectPCIdevice:=found;
end;



function readPCIRegisterByte(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;var resulty:byte):boolean;
var okay:boolean;
    res:byte;
begin
  okay:=false;
  res:=0;
  asm
    db 66h; pusha
    mov AX,0B108h
    mov BH,busNum
    mov BL,DeviceNum
    shl BL,3
    or BL,functionNum
    mov DI,RegisterNumber
    int 1Ah
    jc @noaction
    mov res,cl
    mov okay,true
  @noaction:
    db 66h; popa
  end;
  resulty:=res;
  readPCIRegisterByte:=okay;
end;

function readPCIRegisterWord(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;var resulty:Word):boolean;
var okay:boolean;
    res:word;
begin
  okay:=false;
  res:=0;
  asm
    db 66h; pusha
    mov AX,0B109h
    mov BH,busNum
    mov BL,DeviceNum
    shl BL,3
    or BL,functionNum
    mov DI,RegisterNumber
    int 1Ah
    jc @noaction
    mov res,cx
    mov okay,true
  @noaction:
    db 66h; popa
  end;
  resulty:=res;
  readPCIRegisterWord:=okay;
end;

function readPCIRegisterDWord(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;var resulty:longint):boolean;
var okay:boolean;
    res:longint;
begin
  okay:=false;
  res:=0;
  asm
    db 66h; pusha
    mov AX,0B10ah
    mov BH,busNum
    mov BL,DeviceNum
    shl BL,3
    or BL,functionNum
    mov DI,RegisterNumber
    int 1Ah
    jc @noaction
    db 66h; mov word ptr res,cx { MOV RES, ECX }
    mov okay,true
  @noaction:
    db 66h; popa
  end;
  resulty:=res;
  readPCIRegisterDword:=okay;
end;

function writePCIRegisterByte(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;input:byte):boolean;
var okay:boolean;
begin
  okay:=false;
  asm
    db 66h; pusha
    mov AX,0B10bh
    mov BH,busNum
    mov BL,DeviceNum
    shl BL,3
    or BL,functionNum
    mov DI,RegisterNumber
    mov CL,input
    int 1Ah
    jc @noaction
    mov okay,true
  @noaction:
    db 66h; popa
  end;
  writePCIRegisterByte:=okay;
end;

function writePCIRegisterWord(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;input:word):boolean;
var okay:boolean;
begin
  okay:=false;
  asm
    db 66h; pusha
    mov AX,0B10ch
    mov BH,busNum
    mov BL,DeviceNum
    shl BL,3
    or BL,functionNum
    mov DI,RegisterNumber
    mov CX,input
    int 1Ah
    jc @noaction
    mov okay,true
  @noaction:
    db 66h; popa
  end;
  writePCIRegisterWord:=okay;
end;

function writePCIRegisterDWord(RegisterNumber:word;BusNum,DeviceNum,FunctionNum:Byte;input:longint):boolean;
var okay:boolean;
    res:byte;
begin
  okay:=false;
  res:=0;
  asm
    db 66h; pusha
    mov AX,0B10dh
    mov BH,busNum
    mov BL,DeviceNum
    shl BL,3
    or BL,functionNum
    mov DI,RegisterNumber
    db 66h; mov CX, word ptr input
    int 1Ah
    jc @noaction
    mov okay,true
  @noaction:
    db 66h; popa
  end;
  writePCIRegisterDWord:=okay;
end;


{Find the size of an MMIOBAR}
function MMIOBARSIZE32(reg:word;Bus,Dev,Func:Byte):longint;
var tmpdw,tr:longint;
begin
readPCIRegisterDWord(reg,bus,dev,func,tmpdw);
    writePCIRegisterDWord(reg,bus,dev,func,$FFFFFFFF);
    readPCIRegisterDWord(reg,bus,dev,func,tr);
writePCIRegisterDWord(reg,bus,dev,func,tmpdw);
    tr:=tr and $FFFFFFF0;
    result:=longint(not(longint(tr)));
    result:=result+1;
end;


end.
