unit Upper4gb;

interface
uses dialogs,wintypes,winprocs,misc;

type pab=^pb;
pb=array[0..$FFFE] of byte;
type paw=^pw;
pw=array[0..$7FFE] of word;
type palng=^pl;
pl=array[0..$3FFE] of longint;

{Point a selector at a hardware Memory location}
type segselmem=record
physical:pointer;{hardware memory address}
linear:pointer;
length:pointer;{The extent of the hardware memory we wish to view}
end;

var mem:array[0..2] of segselmem;

{mem[0] is currently for Temporary use}
var LMB:pointer;{A long pointer for a hardware memory address above 1mb}

{mem[1] to share with BUS Masters (Allocated when program first starts)}
var MyMem:pointer;{A long pointer for a hardware memory address above 1mb}
const BMMdefaddr1=$30000000;{How about Between 512mb and 1gb?}
const BMMdefsiz1=$800000;{selectors (HugeInc/HugeDec)}

{mem[2] Use this for devSNB MMIO BAR0}
var SNB:pointer;{A long pointer for a hardware memory address above 1mb}
{const snbsiz=4 megabytes;(or the size of MMIO BAR0 space)}

{mem[3]}

{The cursor address is a physical linear contiguous address}
const
 cursorAVGAbase=$2F000000;{for cursor A bitmap}
{Looks like the ring buffers are defined using 4kb pointers defined within the GTT}
RingBuffer0offs={GTT+}$00001000;{16 4kb entries}
RingBuffer1offs={GTT+}$00001010;{16 4kb entries}
{RingBuffer2offs=GTT+ $00001020;(16 4kb entries)}


function allocateLMB(memv:segselmem;var LMBv:pointer):boolean;
procedure freeLMB(memv:segselmem;var LMBv:pointer);
implementation


function allocateLMB(memv:segselmem;var LMBv:pointer):boolean;
begin
memv.linear:=MapPhysicalToLinear(memv.Physical, memv.Length);
 if not(longint(memv.linear)=0)then begin
  LMBv:=pointer(CreateHugePointer (pointer(memv.Linear), pointer(memv.Length)));
  result:=true;
 end else begin
  showmessage('Linear memory error!');
  result:=false;
 end;

end;


procedure freeLMB(memv:segselmem;var LMBv:pointer); begin
if not(LMBv=nil)then begin FreeSelector(HIWORD(longint(LMBv)));end;
end;



end.
