unit Wout;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, MMSystem, StdCtrls, Spin;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit2: TEdit;
    Memo1: TMemo;
    ScrollBar1: TScrollBar;
    SpinEdit1: TSpinEdit;
    ScrollBar2: TScrollBar;
    Button2: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
var lastn:string;
var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
 NumDevs     : Integer;
 waveCaps    : TWaveOutCaps;
 Volume      : longint;
 Left, Right : Word;
 Version     : Word;
 tmp,ste:byte;
 tog:boolean;
 x,y:real;
var nam:pchar;
begin
memo1.lines.clear;

{// We should have at least one device}
  NumDevs := waveOutGetNumDevs;
  spinedit1.maxvalue:=numdevs-1;
  edit1.text:= Format(' %d', [NumDevs])+' Devices';
{// for the 1st device (hard-coded)}
{// Get Device Caps}
  waveOutGetDevCaps(word(spinedit1.value), @waveCaps, SizeOf(waveCaps));
{// Show device caps}
{  memo1.lines.add('wMid='+inttostr(waveCaps.wMid)+';'+'wPid='+inttostr(wavecaps.wPid));}
{  Memo1.Lines.Add('szsupport: '+inttostr(waveCaps.dwsupport));}
  nam:=waveCaps.szPName;
  nam[31]:=char(0);{maximum of 32 chars}
  Memo1.Lines.Add('szPName: '+strpas(nam));
  lastn:=strpas(nam);
  Version := waveCaps.vDriverVersion;
  Memo1.Lines.Add(Format('Driver Version: %d.%d', [Hi(Version), Lo(Version)]));
  Case waveCaps.wChannels of
    1 : Memo1.Lines.Add('MONO');
    2 : Memo1.Lines.Add('Stereo');
  End;
{ // Standard formats}
  If waveCaps.dwSupport AND WAVECAPS_PITCH <> 0 Then memo1.lines.add('Pitch adjustment');
  If waveCaps.dwSupport AND WAVECAPS_LRVOLUME <> 0 Then memo1.lines.add('Independent L/R volume');



x:=11.025;
y:=1;
tog:=true;
ste:=1;
for tmp:=0 to 11 do begin
tog:=not tog;
if(y>2)then ste:=2 else ste:=1;
if((waveCaps.dwFormats shr tmp) and 1)=1 then begin
memo1.lines.add(inttostr(trunc(x))+' kHz ('+inttostr(byte(tog)+1)+' channel) '+inttostr(ste * 8)+'bits');
end;

if(y=4)then begin x:=x*2;{+11.025};y:=0; end;
y:=y+1;
end;


if(1=2) then begin
memo1.lines.add('');
 If waveCaps.dwFormats AND WAVE_FORMAT_1M08 <> 0 Then
  Memo1.Lines.Add('11.025 kHz, mono, 8-bit');
 If waveCaps.dwFormats AND WAVE_FORMAT_1M16 <> 0 Then
  Memo1.Lines.Add('11.025 kHz, mono, 16-bit');

 If waveCaps.dwFormats AND WAVE_FORMAT_1S08
  <> 0 Then Memo1.Lines.Add('11.025 kHz, stereo, 8-bit  ');
 If waveCaps.dwFormats AND WAVE_FORMAT_1S16
  <> 0 Then Memo1.Lines.Add('11.025 kHz, stereo, 16-bit  ');
 If waveCaps.dwFormats AND WAVE_FORMAT_2S08
  <> 0 Then Memo1.Lines.Add('22.05 kHz, mono, 8-bit  ');
 If waveCaps.dwFormats AND WAVE_FORMAT_2S16
  <> 0 Then Memo1.Lines.Add('22.05 kHz, mono, 16-bit  ');
 If waveCaps.dwFormats AND WAVE_FORMAT_4M08
  <> 0 Then Memo1.Lines.Add('22.05 kHz, stereo, 8-bit  ');
 If waveCaps.dwFormats AND WAVE_FORMAT_4M16
  <> 0 Then Memo1.Lines.Add('22.05 kHz, stereo, 16-bit  ');
 If waveCaps.dwFormats AND WAVE_FORMAT_4S08
  <> 0 Then Memo1.Lines.Add('44.1 kHz, mono, 8-bit  ');
 If waveCaps.dwFormats AND WAVE_FORMAT_4S16
  <> 0 Then Memo1.Lines.Add('44.1 kHz, stereo, 16-bit  ');
  end;


 If waveCaps.dwFormats AND $1000
  <> 0 Then Memo1.Lines.Add('48 kHz, mono, 8-bit  ');
 If waveCaps.dwFormats AND $2000
  <> 0 Then Memo1.Lines.Add('48 kHz, stereo, 8-bit  ');
 If waveCaps.dwFormats AND $4000
  <> 0 Then Memo1.Lines.Add('48 kHz, mono, 16-bit  ');
 If waveCaps.dwFormats AND $8000
  <> 0 Then Memo1.Lines.Add('48 kHz, stereo, 16-bit  ');

{Higer sample rate!}
 If waveCaps.dwFormats AND $10000
  <> 0 Then Memo1.Lines.Add('?????, mono, 8-bit  ');
 If waveCaps.dwFormats AND $20000
  <> 0 Then Memo1.Lines.Add('?????, stereo, 8-bit  ');
 If waveCaps.dwFormats AND $40000
  <> 0 Then Memo1.Lines.Add('?????, mono, 16-bit  ');
 If waveCaps.dwFormats AND $80000
  <> 0 Then Memo1.Lines.Add('?????, stereo, 16-bit  ');

{Maxium sample rate!}
 If waveCaps.dwFormats AND $100000
  <> 0 Then Memo1.Lines.Add('?????, mono, 8-bit  ');
 If waveCaps.dwFormats AND $200000
  <> 0 Then Memo1.Lines.Add('?????, stereo, 8-bit  ');
 If waveCaps.dwFormats AND $400000
  <> 0 Then Memo1.Lines.Add('?????, mono, 16-bit  ');
 If waveCaps.dwFormats AND $800000
  <> 0 Then Memo1.Lines.Add('?????, stereo, 16-bit  ');

{Super sample rate!}
 If waveCaps.dwFormats AND $1000000
  <> 0 Then Memo1.Lines.Add('?????, mono, 8-bit  ');
 If waveCaps.dwFormats AND $2000000
  <> 0 Then Memo1.Lines.Add('?????, stereo, 8-bit  ');
 If waveCaps.dwFormats AND $4000000
  <> 0 Then Memo1.Lines.Add('?????, mono, 16-bit  ');
 If waveCaps.dwFormats AND $8000000
  <> 0 Then Memo1.Lines.Add('?????, stereo, 16-bit  ');

{Maxium sample rate!}
 If waveCaps.dwFormats AND $1000000
  <> 0 Then Memo1.Lines.Add('?????, mono, 8-bit  ');
 If waveCaps.dwFormats AND $2000000
  <> 0 Then Memo1.Lines.Add('?????, stereo, 8-bit  ');
 If waveCaps.dwFormats AND $4000000
  <> 0 Then Memo1.Lines.Add('?????, mono, 16-bit  ');
 If waveCaps.dwFormats AND $8000000
  <> 0 Then Memo1.Lines.Add('?????, stereo, 16-bit  ');

  {
WAVE_FORMAT_1S08	11.025 kHz, stereo, 8-bit
WAVE_FORMAT_1S16	11.025 kHz, stereo, 16-bit
WAVE_FORMAT_2M08	22.05 kHz, mono, 8-bit
WAVE_FORMAT_2M16	22.05 kHz, mono, 16-bit
WAVE_FORMAT_2S08	22.05 kHz, stereo, 8-bit
WAVE_FORMAT_2S16	22.05 kHz, stereo, 16-bit
WAVE_FORMAT_4M08	44.1 kHz, mono, 8-bit
WAVE_FORMAT_4M16	44.1 kHz, mono, 16-bit
WAVE_FORMAT_4S08	44.1 kHz, stereo, 8-bit
WAVE_FORMAT_4S16	44.1 kHz, stereo, 16-bit
}

{// If Volume Control Supported}
  If waveCaps.dwSupport AND WAVECAPS_VOLUME <> 0 Then
   Begin
    waveOutGetVolume(word(spinedit1.value), @Volume);
    Left  := Word(Volume);
    Right := Word(Volume shr 16);

    scrollbar1.position:=($FFFF-left)shr 8;
    scrollbar2.position:=($FFFF-right)shr 8;

{// Show values of WAVE Device on volume control panel}
    Edit2.Text := Format('Left:%d, Right:%d', [Left, Right]);
{   waveOutSetVolume(0, $40008000);}
   End;



end;

function stereo(v:byte):string;
begin
result:='';
if(v=1)then result:='Mono';
if(v=2)then result:='Stereo';
if(v=3)then result:='Trio';
if(v=4)then result:='Quad';
end;


procedure TForm1.Button2Click(Sender: TObject);
var waveouthandle:hwave;
var pcmwf:tpcmwaveformat;{for the sound driver }
var re:longint;
var tmp,bitsps,chr:word;
begin
memo1.lines.clear;


for tmp:=1 to 16 do begin
 for bitsps:=0 to 7 do begin
  for chr:=1 to 2 do begin
{}


 with pcmwf.wf do
  begin
   wFormatTag:= wave_Format_PCM;
   pcmwf.wBitsPerSample := 1 shl bitsps;
   nChannels := chr;
   nSamplesPerSec := $FFFF div (tmp);
   if((pcmwf.wBitsPerSample and $7)>0)then  nBlockAlign := 1 else
   if(pcmwf.wBitsPerSample=8)then nBlockAlign := 1 else
   if(pcmwf.wBitsPerSample>15)then  nBlockAlign := nChannels*(pcmwf.wBitsPerSample div 8);
   nAvgBytesPerSec := nBlockAlign * nSamplesPerSec;
  end;
re:=waveoutopen(@waveouthandle,word(spinedit1.value),@pcmwf,0,0,WAVE_FORMAT_QUERY);
if(re>0)then begin
end else begin
Memo1.Lines.Add(inttostr(pcmwf.wBitsPerSample)+'-bit,'+
stereo(pcmwf.wf.nChannels)+','+inttostr(pcmwf.wf.nSamplesPerSec)+'Hz');
end;




 with pcmwf.wf do
  begin
   wFormatTag:= wave_Format_PCM;
   pcmwf.wBitsPerSample := 1 shl bitsps;
   nChannels := chr;
   nSamplesPerSec := 48000 div (tmp);
   if((pcmwf.wBitsPerSample and $7)>0)then  nBlockAlign := 1 else
   if(pcmwf.wBitsPerSample=8)then nBlockAlign := 1 else
   if(pcmwf.wBitsPerSample>15)then  nBlockAlign := nChannels*(pcmwf.wBitsPerSample div 8);
   nAvgBytesPerSec := nBlockAlign * nSamplesPerSec;
  end;
re:=waveoutopen(@waveouthandle,word(spinedit1.value),@pcmwf,0,0,WAVE_FORMAT_QUERY);
if(re>0)then begin
end else begin
Memo1.Lines.Add(inttostr(pcmwf.wBitsPerSample)+'-bit,'+
stereo(pcmwf.wf.nChannels)+','+inttostr(pcmwf.wf.nSamplesPerSec)+'Hz');
end;



 with pcmwf.wf do
  begin
   wFormatTag:= wave_Format_PCM;
   pcmwf.wBitsPerSample := 1 shl bitsps;
   nChannels := chr;
   nSamplesPerSec := 44100 div (tmp);
   if((pcmwf.wBitsPerSample and $7)>0)then  nBlockAlign := 1 else
   if(pcmwf.wBitsPerSample=8)then nBlockAlign := 1 else
   if(pcmwf.wBitsPerSample>15)then  nBlockAlign := nChannels*(pcmwf.wBitsPerSample div 8);
   nAvgBytesPerSec := nBlockAlign * nSamplesPerSec;
  end;
re:=waveoutopen(@waveouthandle,word(spinedit1.value),@pcmwf,0,0,WAVE_FORMAT_QUERY);
if(re>0)then begin
end else begin
Memo1.Lines.Add(inttostr(pcmwf.wBitsPerSample)+'-bit,'+
stereo(pcmwf.wf.nChannels)+','+inttostr(pcmwf.wf.nSamplesPerSec)+'Hz');
end;


{}
end;
end;
end;



end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var lo:longint;
var w1,w2:word;
begin
w1:=$FF00-word(scrollbar1.position shl 8);
w2:=$FF00-word(scrollbar2.position shl 8);
lo:=longint(w2) shl 16;
lo:=lo+longint(w1);



WAVEOUTSETVOLUME(
word(spinedit1.value),lo
);
lo:=0;
WAVEOUTGETVOLUME(word(spinedit1.value),@lo);
caption:=inttohex(lo,8);


end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
var lo:longint;
begin
ScrollBar1change(sender);

end;

end.
